unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, ZConnection, ZSqlProcessor, ZDataset, ZSqlUpdate, FileUtil,
  Forms, Controls, Graphics, Dialogs, StdCtrls, DbCtrls, DBGrids, db;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Datasource1: TDatasource;
    Datasource2: TDatasource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    ZQuery1CONTINENT: TStringField;
    ZQuery1COUNTRY_ID: TLongintField;
    ZQuery1COUNTRY_NAME: TStringField;
    ZQuery2: TZQuery;
    ZQuery2CITY_ID: TLongintField;
    ZQuery2CITY_NAME: TStringField;
    ZQuery2COUNTRY_ID: TLongintField;
    ZQuery2LAT: TLongintField;
    ZQuery2LON: TLongintField;
    ZSQLProcessor1: TZSQLProcessor;
    ZUpdateSQL1: TZUpdateSQL;
    ZUpdateSQL2: TZUpdateSQL;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure DBGrid1Enter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ZQuery1BeforeDelete(DataSet: TDataSet);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

  aa : string ;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin

    ZConnection1.Connected := false ;

             // Create file with Database Firebird, ...
           // Crea archivo con la Base de Datos Firebird, ...
    if FileExists( aa )
      then DeleteFile( aa );
    ZConnection1.Database := aa ;
    ZConnection1.Protocol := 'firebird-2.1';
    ZConnection1.Properties.Add (
      'CreateNewDatabase=CREATE DATABASE ' + QuotedStr ( aa )
    + ' USER  ' + QuotedStr ('sysdba') + ' PASSWORD  ' + QuotedStr ('masterkey')
    + ' PAGE_SIZE 4096'
  //  + ' DEFAULT CHARACTER SET ISO8859_1'
    );

    ZConnection1.User     := 'sysdba' ;
    ZConnection1.Password := 'masterkey' ;

    ZConnection1.Connect;

               // ... create the tables and add the information
             // ... crea las tablas y añade la información.
    ZSQLProcessor1.Script.LoadFromFile('create.sql');
    ZSQLProcessor1.Execute;

    ShowMessage( 'The DB has been created ' + #13+ #13+
                 'La BD ha sido creada');
    ZQuery1.Open;
    ZQuery2.Open;
    if sender = button1
      then DBGrid1.SetFocus;


end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close ;
end;

procedure TForm1.DBGrid1Enter(Sender: TObject);
begin

  if sender = DBGrid1
  then
    begin
      DBNavigator1.Visible := true ;
      DBNavigator2.Visible := false ;
    end
  else
    begin
      DBNavigator2.Visible := true ;
      DBNavigator1.Visible := false ;
    end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  aa := ExtractFilePath ( Application.ExeName ) + 'cities.fdb' ;

  if FileExists( aa )
  then
    begin
      ZConnection1.Database := aa ;
      ZQuery1.Open;
      ZQuery2.Open;
    end
  else
    Button1Click( nil );

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ZConnection1.Connected:= false;
end;

procedure TForm1.ZQuery1BeforeDelete(DataSet: TDataSet);
begin
    // Before erasing the registration of a country, it is necessary
    // to erase the cities that belong to that country
  // Antes de borrar el registro de un pais, hay que borrar las ciudades
  // que pertenecen a ese país
  ZSQLProcessor1.Script.Clear;
  ZSQLProcessor1.Script.Add(
      'Delete from CITY where COUNTRY_ID = '
      + IntToStr( ZQuery1COUNTRY_ID.AsInteger ) + ' ;' )     ;

  ZSQLProcessor1.Execute ;

end;

end.

